# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section         free

Name:           ops4j-pax-web
Summary:        Pax web
Url:            http://www.ops4j.org/
Version:        1.0.1
Release:        1%{?dist}
Epoch:          0
License:        Apache 2.0 License
Group:          Development/Libraries
Source0:        ops4j-org.ops4j.pax.web-web-1.0.1-0-gd938102.zip
# get it from https://github.com/ops4j/org.ops4j.pax.web/tree/web-1.0.1

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml

Patch0:          ops4j-pax-web-pom.patch
Patch1:          ops4j-pax-web-jsp-pom.patch
Patch2:          ops4j-pax-web-jsp-osgi-bnd.patch
Patch3:          ops4j-pax-web-runtime-osgi-bnd.patch
Patch4:          ops4j-pax-web-jetty-bundle-osgi-bnd.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  mojo-maven2-plugin-build-helper
BuildRequires:  mojo-parent
BuildRequires:  apache-commons-parent
BuildRequires:  apache-felix-maven-bundle-plugin
BuildRequires:  geronimo-genesis

BuildRequires:  apache-felix-fileinstall
BuildRequires:  jetty7
BuildRequires:  ops4j-pax-master
BuildRequires:  ops4j-base
BuildRequires:  ops4j-pax-swissbox
BuildRequires:  tomcat6-lib

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  apache-felix-fileinstall
Requires:  jetty7
Requires:  ops4j-base
Requires:  ops4j-pax-swissbox

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
Pax Web - OPS4J implementation of osgi http service using jetty 7.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n ops4j-org.ops4j.pax.web-c2a0b9c
chmod -R go=u-w *
cp %{SOURCE1} settings.xml
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install 
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Daggregate=true \
        javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}/samples
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.ops4j.pax web %{version} JPP/%{name} web
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-web.pom

%add_to_maven_depmap org.ops4j.pax.web pax-web-api %{version} JPP/%{name} api
install -m 644 pax-web-api/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-api.pom
install -m 644 pax-web-api/target/pax-web-api-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/api-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.web pax-web-deployer %{version} JPP/%{name} deployer
install -m 644 pax-web-deployer/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-deployer.pom
install -m 644 pax-web-deployer/target/pax-web-deployer-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/deployer-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.web pax-web-extender-war %{version} JPP/%{name} extender-war
install -m 644 pax-web-extender-war/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-extender-war.pom
install -m 644 pax-web-extender-war/target/pax-web-extender-war-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/extender-war-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.web pax-web-extender-whiteboard %{version} JPP/%{name} extender-whiteboard
install -m 644 pax-web-extender-whiteboard/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-extender-whiteboard.pom
install -m 644 pax-web-extender-whiteboard/target/pax-web-extender-whiteboard-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/extender-whiteboard-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.web pax-web-jetty-bundle %{version} JPP/%{name} jetty-bundle
install -m 644 pax-web-jetty-bundle/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jetty-bundle.pom
install -m 644 pax-web-jetty-bundle/target/pax-web-jetty-bundle-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jetty-bundle-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.web pax-web-jetty %{version} JPP/%{name} jetty
install -m 644 pax-web-jetty/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jetty.pom
install -m 644 pax-web-jetty/target/pax-web-jetty-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jetty-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.web pax-web-jsp %{version} JPP/%{name} jsp
install -m 644 pax-web-jsp/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jsp.pom
install -m 644 pax-web-jsp/target/pax-web-jsp-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jsp-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.web pax-web-runtime %{version} JPP/%{name} runtime
install -m 644 pax-web-runtime/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-runtime.pom
install -m 644 pax-web-runtime/target/pax-web-runtime-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/runtime-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.web pax-web-spi %{version} JPP/%{name} spi
install -m 644 pax-web-spi/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-spi.pom
install -m 644 pax-web-spi/target/pax-web-spi-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/spi-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -m 644 samples/authentication/target/authentication-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/samples
install -m 644 samples/helloworld-hs/target/helloworld-hs-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/samples
install -m 644 samples/helloworld-jsp/target/helloworld-jsp-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/samples
install -m 644 samples/helloworld-wc/target/helloworld-wc-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/samples
install -m 644 samples/jetty-config-fragment/target/jetty-config-fragment-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/samples
install -m 644 samples/provision/target/provision-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/samples
install -m 644 samples/war/target/war-%{version}.war $RPM_BUILD_ROOT%{_javadir}/%{name}/samples
install -m 644 samples/whiteboard/target/whiteboard-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/samples

(cd $RPM_BUILD_ROOT%{_javadir}/%{name}/samples && for f in *-%{version}.?ar; do ln -sf ${f} `echo $f| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_javadir}/%{name}/samples/*.?ar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Wed Jun 22 2011 Ralph Apel <r.apel at r-apel.de> 0:1.0.1-1
- First standalone release
